#!/usr/bin/env python3
import os
import shutil
import sipconfig

# The name of the SIP build file generated by SIP and used by the build
# system.
build_file = "pyvisitor.sbf"

# Get the SIP configuration information.
config = sipconfig.Configuration()

# Run SIP to generate the code.
os.system(" ".join([config.sip_bin,
                    "-c", ".", "-b", build_file, "-e", "visitor.sip"]))

# Create the Makefile.
makefile = sipconfig.SIPModuleMakefile(config, build_file)

makefile.extra_cxxflags = ['-EHsc', '-wd4251']
makefile.extra_libs = ["Debug\\sip_visitor_test"]

# Obviously, you will need a better deployment solution.
shutil.copy(makefile.extra_libs[0] + '.dll', '.')

# Generate the Makefile itself.
makefile.generate()
