#ifndef SIP_V_T
#define SIP_V_T

#include <vector>
#include <memory>

#ifdef SIP_VISITOR_TEST_EXPORTS
#define EXPORT __declspec(dllexport)
#else
#define EXPORT __declspec(dllimport)
#endif

class EXPORT Node {
public:
	explicit Node(int n) : n_(n) {};
	int getN() const { return n_; }
private:
	int n_;
};
struct EXPORT NodeVisitor {
	virtual void OnNode(Node* n) = 0;
};
struct EXPORT Graph {
public:
	void addNode(int num);
	void accept(NodeVisitor *nv);
private:
	std::vector< std::shared_ptr<Node> > nodes_;
};
#endif